local HeadCount = LibStub("AceAddon-3.0"):GetAddon("HeadCount2")
local GetItemInfo = GetItemInfo

local Fields = {
	itemId = 0,
	player = "",
	cost   = 0,
	looted = 0,
	quantity = 0,
	zone = 0,
	source = "",
	note = "",
	_iname = "",
	_icolor = "",
	_ilink = "",
	_irarity = 0,
	_ilevel = 0,
	_itype = 0,
	_isubtype = 0,
	_itexture = "",
	_icon = "Interface\Icons\INV_Misc_QuestionMark",
}

local Loot = HeadCount:NewClassFunctions()

function Loot:ParseLink(link)
	return strmatch(link, "item:(%d+):")
end
function Loot:Name()
	return self._iname
end
function Loot:Color()
	return self._icolor
end
function Loot:Link()
	return self._ilink
end
function Loot:Rarity()
	return self._irarity
end
function Loot:iLevel()
	return self._ilevel
end
function Loot:ItemType()
	return self._itype
end
function Loot:ItemSubType()
	return self._isubtype
end
function Loot:Texture()
	return self._itexture
end
function Loot:TextureIcon()
	return self._icon
end

function Loot:Init(args)
	self.itemId = data["itemId"]
	self.player = data["player"]
	self.cost = data["cost"]
	self.looted = data["looted"]
	self.quantity = data["quantity"]
	self.zone = data["zone"]
	self.source = data["source"]
	self.note = data["note"]
	self._iname, self._ilink, self._irarity, self._ilevel, _, self._itype, self._isubtype, _,_, self._itexture, _ = GetItemInfo(self.itemId)
	self._icolor = strfind(self._ilink, "|c(%x+)|Hitem:[-%d:]+|h%[.-%]|h|r")
	self._icon = strfind(self._itexture, "^.*\\(.*)$") or "Interface\Icons\INV_Misc_QuestionMark"
end
-- Add the Class Definition to Registry
HeadCount:DefineClass("Loot",Fields,Loot)